LeetCode 2483.商店的最少代价:两次遍历 -> 一次遍历

【LetMeFly】2483.商店的最少代价:两次遍历 -> 一次遍历

力扣题目链接:https://leetcode.cn/problems/minimum-penalty-for-a-shop/

给你一个顾客访问商店的日志,用一个下标从 0 开始且只包含字符 'N' 和 'Y' 的字符串 customers 表示:

  • 如果第 i 个字符是 'Y' ,它表示第 i 小时有顾客到达。
  • 如果第 i 个字符是 'N' ,它表示第 i 小时没有顾客到达。

如果商店在第 j 小时关门(0 <= j <= n),代价按如下方式计算:

  • 在开门期间,如果某一个小时没有顾客到达,代价增加 1 。
  • 在关门期间,如果某一个小时有顾客到达,代价增加 1 。

请你返回在确保代价 最小 的前提下,商店的 最早 关门时间。

注意,商店在第 j 小时关门表示在第 j 小时以及之后商店处于关门状态。

示例 1:

复制代码
输入:customers = "YYNY"
输出:2
解释:
- 第 0 小时关门,总共 1+1+0+1 = 3 代价。
- 第 1 小时关门,总共 0+1+0+1 = 2 代价。
- 第 2 小时关门,总共 0+0+0+1 = 1 代价。
- 第 3 小时关门,总共 0+0+1+1 = 2 代价。
- 第 4 小时关门,总共 0+0+1+0 = 1 代价。
在第 2 或第 4 小时关门代价都最小。由于第 2 小时更早,所以最优关门时间是 2 。

示例 2:

复制代码
输入:customers = "NNNNN"
输出:0
解释:最优关门时间是 0 ,因为自始至终没有顾客到达。

示例 3:

复制代码
输入:customers = "YYYY"
输出:4
解释:最优关门时间是 4 ,因为每一小时均有顾客到达。

提示:

  • 1 <= customers.length <= 105
  • customers 只包含字符 'Y' 和 'N' 。

解题方法一:两次遍历

先计算下直接不开门的话总代价是多少。

接着遍历顾客字符串,遍历到第i天时计算这个顾客走之后关门的总代价是多少。

取一个最小总代价对应的关门时间;如有相同则取最早的那个。

假设当前总代价为x,准备改为往后一个顾客时间再关门,那么就看下一个时间是Y还是N。如果为Y则总代价减1否则总代价加1。

  • 时间复杂度 O ( l e n ( c u s t o m e r s ) ) O(len(customers)) O(len(customers))
  • 空间复杂度 O ( 1 ) O(1) O(1)

AC代码

C++
cpp 复制代码
/*
 * @LastEditTime: 2025-12-26 18:42:18
 */
class Solution {
public:
    int bestClosingTime(string customers) {
        int maxium = 0, ans = 0;
        for (char c : customers) {
            maxium += c == 'Y';
        }
        int thisCost = maxium;
        for (int i = 0; i < customers.size(); i++) {
            if (customers[i] == 'Y') {
                thisCost--;
            } else {
                thisCost++;
            }
            if (thisCost < maxium) {
                maxium = thisCost;
                ans = i + 1;
            }
        }
        return ans;
    }
};

解题方法二:一次遍历

不难发现第一次遍历计算得到的"直接不开门"状态下的代价其实没有意义,将其视为0且后续顾客在此基础上浮动即可。

  • 时间复杂度 O ( l e n ( c u s t o m e r s ) ) O(len(customers)) O(len(customers))
  • 空间复杂度 O ( 1 ) O(1) O(1)

AC代码

C++
cpp 复制代码
/*
 * @LastEditTime: 2025-12-26 18:46:24
 */
class Solution {
public:
    int bestClosingTime(string customers) {
        int maxium = 0, ans = 0;
        int thisCost = 0;
        for (int i = 0; i < customers.size(); i++) {
            if (customers[i] == 'Y') {
                thisCost--;
            } else {
                thisCost++;
            }
            if (thisCost < maxium) {
                maxium = thisCost;
                ans = i + 1;
            }
        }
        return ans;
    }
};

同步发文于CSDN和我的个人博客,原创不易,转载经作者同意后请附上原文链接哦~

千篇源码题解已开源

相关推荐
朝朝辞暮i7 小时前
C++ 第 21 课:struct —— 把一组相关数据打包在一起
开发语言·c++·算法
青梅橘子皮7 小时前
Blue---二分算法(二分查找与二分答案)
算法
长河7 小时前
Java的GC(垃圾回收)中,标记无用对象的核心方法是可达性分析算法
java·jvm·算法
月光船幽幽8 小时前
加性偏移外推提升参数识别可靠性
python·算法
Ivanqhz8 小时前
层归一化、残差、前馈网络与激活函数简述
服务器·数据库·人工智能·深度学习·算法
不会就选b9 小时前
算法日常・每日刷题--<动态规划>3
数据结构·算法
-dzk-10 小时前
【堆】LC 347.前 K 个高频元素
算法·堆
H.莓飛10 小时前
【数据结构】栈_OJ题
linux·数据结构·算法·centos
Zootopia62610 小时前
多架 eVTOL集群排班调度方案思考
人工智能·算法·数学建模·matlab·动态规划·无人机·evtol
和裕10 小时前
年度框架直供 vs 零散按需采购:定制纸箱采购成本、交付与服务核心区别全对比
大数据·运维·网络·人工智能·算法